library jaguar_mongo.example;

import 'dart:async';
import 'package:jaguar/jaguar.dart';
import 'package:mongo_dart/mongo_dart.dart';

import 'package:jaguar_mongo/jaguar_mongo.dart';

part 'main.g.dart';

@Api(path: '/api')
class ExampleApi {
  @Post(path: '/')
  /// NOTE: Example of using MongoDb interceptor in basic route
  @WrapOne(#mongoDb)
  Future<String> mongoTest(Context ctx) async {
    // NOTE: This is how the opened mongodb connection is injected
    // into routes
    final Db db = ctx.getInput(MongoDb);
    // DO something with db
    return "ok";
  }

  MongoDb mongoDb(Context ctx) => new MongoDb('mongodb://localhost:27017/test');
}

Future<Null> main(List<String> args) async {
  final api = new JaguarExampleApi(new ExampleApi());

  Jaguar configuration = new Jaguar();
  configuration.addApi(api);

  await configuration.serve();
}
